
        include \MASM32\INCLUDE\MASM32rt.inc

;##########################################################################

WinMain   PROTO :HINSTANCE,:HINSTANCE,:LPSTR,:DWORD
MyDlgProc PROTO :HWND,:UINT,:WPARAM,:LPARAM
MyBtnProc PROTO :HWND,:UINT,:WPARAM,:LPARAM
WndProc   PROTO :HWND,:UINT,:WPARAM,:LPARAM

;##########################################################################

;main window
;   dialog handleMAIN                  IDW_DLGMAIN   1100
;       dialog handledialog1           IDW_DLG1      1120
;           button (handle not saved)  IDC_DLG1BTN   1121
;       dialog handledialog2           IDW_DLG2      1130
;           button (handle not saved)  IDC_DLG2BTN   1131
;       button handlebutton1           IDC_MAINBTN1  1141
;       button handlebutton2           IDC_MAINBTN2  1142

IDW_DLGMAIN  EQU 1100
IDW_DLG1     EQU 1120
IDC_DLG1BTN  EQU 1121
IDW_DLG2     EQU 1130
IDC_DLG2BTN  EQU 1131
IDC_MAINBTN1 EQU 1141
IDC_MAINBTN2 EQU 1142

;##########################################################################

        .DATA

ClassName     db "MainWinClass",0
AppName       db "Main Window",0
classdialog   db "#32770",0
classbutton   db "Button",0
classname1    db "one",0
classname2    db "two",0
classname3    db "three",0
classname4    db "four",0

;**************************************************************************

        .DATA?

hInstance     HINSTANCE ?
CommandLine   LPSTR ?
handleMAIN    dd ?
handledialog1 dd ?
handledialog2 dd ?
handlebutton1 dd ?
handlebutton2 dd ?
subclassDlg   dd ?
subclassBtn   dd ?

;##########################################################################

        .CODE

;**************************************************************************

start:  invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  GetCommandLine
        mov     CommandLine,eax
        invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        invoke  ExitProcess,eax

;**************************************************************************

WinMain PROC    hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

        LOCAL   wc:WNDCLASSEX
        LOCAL   msg:MSG
        LOCAL   hwnd:HWND

; register main window class

        mov     wc.cbSize,SIZEOF WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc,WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        push    hInst
        pop     wc.hInstance
        mov     wc.hbrBackground,COLOR_BTNFACE+1
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,OFFSET ClassName
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc

; create and show main window

        INVOKE  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,
                WS_OVERLAPPEDWINDOW,
                CW_USEDEFAULT,CW_USEDEFAULT,600,400,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        invoke  ShowWindow,hwnd,CmdShow
        invoke  UpdateWindow,hwnd

; message loop

    .WHILE TRUE
        invoke  GetMessage,ADDR msg,NULL,0,0
        .BREAK .IF(!eax)
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg
    .ENDW

; exit WinMain

        mov     eax,msg.wParam
        ret

WinMain ENDP

;**************************************************************************

MyDlgProc PROC  shWnd:HWND,suMsg:UINT,swParam:WPARAM,slParam:LPARAM

    .if suMsg==WM_COMMAND
        movzx   eax,word ptr swParam            ;EAX = wParam low word = control ID
        movzx   edx,word ptr swParam+2          ;EDX = wParam high word = notification code
        .if edx==BN_CLICKED
            .if eax==IDC_MAINBTN1
            invoke  ShowWindow,handledialog2,SW_HIDE
            invoke  ShowWindow,handledialog1,SW_SHOW

            .elseif eax==IDC_MAINBTN2
            invoke  ShowWindow,handledialog1,SW_HIDE
            invoke  ShowWindow,handledialog2,SW_SHOW

            .endif
        .endif

    .elseif suMsg==WM_DESTROY
        invoke  SetWindowLong,shWnd,GWL_WNDPROC,subclassDlg

    .elseif suMsg==WM_CLOSE
        invoke  EndDialog,shWnd,NULL

    .else
        invoke  CallWindowProc,subclassDlg,shWnd,suMsg,swParam,slParam
        ret

    .endif
        xor eax,eax
        ret

MyDlgProc ENDP

;**************************************************************************

MyBtnProc PROC  shWnd:HWND,suMsg:UINT,swParam:WPARAM,slParam:LPARAM

    .if suMsg==WM_DESTROY
        invoke  SetWindowLong,shWnd,GWL_WNDPROC,subclassBtn

    .endif
        invoke  CallWindowProc,subclassBtn,shWnd,suMsg,swParam,slParam
        ret

MyBtnProc ENDP

;**************************************************************************

WndProc PROC    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL

    .elseif uMsg==WM_CREATE

;===========================================================================
; create main windows
;===========================================================================

        invoke  CreateWindowEx,NULL,addr classdialog,addr classname1,
                WS_CHILD or WS_VISIBLE or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,     ;or DS_CONTEXTHELP ???
                CW_USEDEFAULT,CW_USEDEFAULT,500,300,hWnd,IDW_DLGMAIN,hInstance,NULL

        mov     handleMAIN,eax
        invoke  ShowWindow,handleMAIN,SW_SHOW

; create second windows

        invoke  CreateWindowEx,NULL,addr classdialog,addr classname1,
                WS_CHILD or WS_VISIBLE or WS_BORDER,
                10,10,200,200,handleMAIN,IDW_DLG1,hInstance,NULL

        mov     handledialog1,eax

; create sub controls dialog 1

        invoke  CreateWindowEx,NULL,addr classbutton,addr classname1,
                WS_CHILD or WS_VISIBLE,
                20,30,35,20,handledialog1,IDC_DLG1BTN,hInstance,NULL

        invoke  ShowWindow,handledialog1,SW_SHOW

; create second window

        invoke  CreateWindowEx,NULL,addr classdialog,addr classname2,
                WS_CHILD or WS_VISIBLE or WS_BORDER,
                210,10,200,200,handleMAIN,IDW_DLG2,hInstance,NULL

        mov     handledialog2,eax

; create sub controls dialog 2

        invoke  CreateWindowEx,NULL,addr classbutton,addr classname2,
                WS_CHILD or WS_VISIBLE,
                30,40,35,20,handledialog2,IDC_DLG2BTN,hInstance,NULL

        invoke  ShowWindow,handledialog2,SW_HIDE

; create buttons for main windows

        invoke  CreateWindowEx,NULL,addr classbutton,addr classname3,
                WS_CHILD or WS_VISIBLE or WS_TABSTOP,
                10,220,35,20,handleMAIN,IDC_MAINBTN1,hInstance,NULL

        mov     handlebutton1,eax

        invoke  CreateWindowEx,NULL,addr classbutton,addr classname4,
                WS_CHILD or WS_VISIBLE or WS_TABSTOP,
                50,220,35,20,handleMAIN,IDC_MAINBTN2,hInstance,NULL

        mov     handlebutton2,eax

; subclass

        invoke  GetWindowLong,handleMAIN,GWL_WNDPROC
        mov     subclassDlg,eax
        invoke  SetWindowLong,handleMAIN,GWL_WNDPROC,MyDlgProc

        invoke  GetWindowLong,handlebutton1,GWL_WNDPROC
        mov     subclassBtn,eax
        invoke  SetWindowLong,handlebutton1,GWL_WNDPROC,MyBtnProc
        invoke  SetWindowLong,handlebutton2,GWL_WNDPROC,MyBtnProc

    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret

    .endif
        xor     eax,eax
        ret

WndProc ENDP

;##########################################################################

        END     start

